package com.djhk.common.utils.sign;

import org.apache.commons.codec.binary.Base64;

import javax.crypto.Cipher;
import java.security.*;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;

/**
 * RSA加密解密
 * 
 * @author gqj
 **/
public class RsaUtils
{
    // Rsa 私钥
    public static String privateKey = "MIIEvAIBADANBgkqhkiG9w0BAQEFAASCBKYwggSiAgEAAoIBAQDV4NjZNkLLJ6wq\n" +
            "34mn0527PIXdEZcM8a7RPhQCeJy+/9KBFwMGFwvtBKgSOWqfDJOM4XJM+DCnnqHN\n" +
            "lB3jkAd029d5c6ShXtEUQ4gmutTCZndnG867EzxEH78yw00MOiopswAaAH3QWdOZ\n" +
            "tzrnqLCeVFX+tf38mBKgdmL+eVV0XooQM2MOIxe6SaGteY7LZD/Tkv6h71xhzyfG\n" +
            "A9WcQMgwigZSkqS2xU8qEX3iCJ/2bKxkRpPD2rZY+rSIbcchqb9z6fXLpW/AWk/D\n" +
            "zYQfRYIyePRafF2yi684WTXwbAEvxTznN8T9yQmZ+aCKOBdxBBeDWB4SiXbkW04W\n" +
            "xvhC/1e3AgMBAAECggEAERI8XMIO/MYy4M0s4J9sdJh1GtsfkmHsETmCQVw9LqWe\n" +
            "uL0Mebz3L7jybVn137ISSOlpxSj+QTLROWZ8KEDDx5kQjtojJto5mAN355d8CfRB\n" +
            "zZIToyz633klOrkJ+lLeMKvf8zNc13eEAz3zzq/RQSH8JzOBjVraCcLJTgSDRKFt\n" +
            "yTy4keyxbhwafIBlzWNkrzPVt0/1rox4BPVUU11x8/o8e18RJkLg7D/z8YQcXRsT\n" +
            "lOcpxBW/KNq2ilq3IRY6XMmllnTYdanX2JJcSiiET1SuJxaosN2rLY0DxKQkIOoX\n" +
            "6nL/6uW8sHz07B6aJAooHAUBFY4OxnvBbWMrUS+iUQKBgQDumUfBpwravV6/wnAz\n" +
            "SpuZvYTz9hZFR2MFHFetYmCTlYH7RedogXvAa7ZPoW7BBgXEU44PPyMH9vhWPKvu\n" +
            "TgMUViGzkvSWSN0WymkLGtEmeUjH2+T7uwiyK9igH/9YxXLVDCV3YAOhp7sE+PG4\n" +
            "bxbwG6vYB8eTLIsH8iYCauyg3wKBgQDlegcYPnZhKd3JXrvrySevTnTEx3cp3vRB\n" +
            "hbvzVoQvQCR0SZ668bOAZe3wd+ZFQoyOT+ndSBsdASpIg8elpW9k7+CDmVL9Ecdw\n" +
            "KDeNsXaisUKyslQ/yB8BAI0+q6z5mjjqsS8PtqYne4krsGxiTdD1L1asl0EdZAEF\n" +
            "iV1wXrTsKQKBgDWyP0jgq/uwVIt5WcDhUIVX9nzk6/wpZap3x2+YzT1Jj1gaUkrd\n" +
            "oRkb5IqlPQSps1CMsVLTFbIsLZVS0CqwWdcQz0LXlr3fpgoEAYHjRiCPeQapgS35\n" +
            "2KooXfcjXFcBEKfLtP7Zl9egpOEomVW1gocE4zaaAZsokh12rIEsyRYnAoGAb64G\n" +
            "u+bSSBFPDgyb2nGoban6LDaDKQ6Hw0eppBDL/g7ybuHRbVvqJyf0N96yY6yyqSP9\n" +
            "RiMsht4lTOtNg7FS2EXh90nsWJuJe20nND9U5HLuafdeBziG1j8FfqWgZk2HO7kF\n" +
            "lVkn3flCVc/jv6ftdRYX0aE/IGWmFaK3pdOBq5kCgYAVwVXKOuHJggdYxVED/OXc\n" +
            "T7xLu0741PjfLzzQEsCP3RvD2TRymA2ixcY7gHrZ7rZ4cn4NcsINI3xVHsbBZ5a9\n" +
            "mMNkF0+rg0SOKp96NNI85nAUo1vQh7kP2nvDaZdSsDxfhIovkkeUjWPy2oJR7QOh\n" +
            "Ynm+EHYEwXfPTCqw25jz+A==";

    /**
     * 私钥解密
     *
     * @param text 待解密的文本
     * @return 解密后的文本
     */
    public static String decryptByPrivateKey(String text) throws Exception
    {
        return decryptByPrivateKey(privateKey, text);
    }

    /**
     * 公钥解密
     *
     * @param publicKeyString 公钥
     * @param text 待解密的信息
     * @return 解密后的文本
     */
    public static String decryptByPublicKey(String publicKeyString, String text) throws Exception
    {
        X509EncodedKeySpec x509EncodedKeySpec = new X509EncodedKeySpec(Base64.decodeBase64(publicKeyString));
        KeyFactory keyFactory = KeyFactory.getInstance("RSA");
        PublicKey publicKey = keyFactory.generatePublic(x509EncodedKeySpec);
        Cipher cipher = Cipher.getInstance("RSA");
        cipher.init(Cipher.DECRYPT_MODE, publicKey);
        byte[] result = cipher.doFinal(Base64.decodeBase64(text));
        return new String(result);
    }

    /**
     * 私钥加密
     *
     * @param privateKeyString 私钥
     * @param text 待加密的信息
     * @return 加密后的文本
     */
    public static String encryptByPrivateKey(String privateKeyString, String text) throws Exception
    {
        PKCS8EncodedKeySpec pkcs8EncodedKeySpec = new PKCS8EncodedKeySpec(Base64.decodeBase64(privateKeyString));
        KeyFactory keyFactory = KeyFactory.getInstance("RSA");
        PrivateKey privateKey = keyFactory.generatePrivate(pkcs8EncodedKeySpec);
        Cipher cipher = Cipher.getInstance("RSA");
        cipher.init(Cipher.ENCRYPT_MODE, privateKey);
        byte[] result = cipher.doFinal(text.getBytes());
        return Base64.encodeBase64String(result);
    }

    /**
     * 私钥解密
     *
     * @param privateKeyString 私钥
     * @param text 待解密的文本
     * @return 解密后的文本
     */
    public static String decryptByPrivateKey(String privateKeyString, String text) throws Exception
    {
        PKCS8EncodedKeySpec pkcs8EncodedKeySpec5 = new PKCS8EncodedKeySpec(Base64.decodeBase64(privateKeyString));
        KeyFactory keyFactory = KeyFactory.getInstance("RSA");
        PrivateKey privateKey = keyFactory.generatePrivate(pkcs8EncodedKeySpec5);
        Cipher cipher = Cipher.getInstance("RSA");
        cipher.init(Cipher.DECRYPT_MODE, privateKey);
        byte[] result = cipher.doFinal(Base64.decodeBase64(text));
        return new String(result);
    }

    /**
     * 公钥加密
     *
     * @param publicKeyString 公钥
     * @param text 待加密的文本
     * @return 加密后的文本
     */
    public static String encryptByPublicKey(String publicKeyString, String text) throws Exception
    {
        X509EncodedKeySpec x509EncodedKeySpec2 = new X509EncodedKeySpec(Base64.decodeBase64(publicKeyString));
        KeyFactory keyFactory = KeyFactory.getInstance("RSA");
        PublicKey publicKey = keyFactory.generatePublic(x509EncodedKeySpec2);
        Cipher cipher = Cipher.getInstance("RSA");
        cipher.init(Cipher.ENCRYPT_MODE, publicKey);
        byte[] result = cipher.doFinal(text.getBytes());
        return Base64.encodeBase64String(result);
    }

    /**
     * 构建RSA密钥对
     *
     * @return 生成后的公私钥信息
     */
    public static RsaKeyPair generateKeyPair() throws NoSuchAlgorithmException
    {
        KeyPairGenerator keyPairGenerator = KeyPairGenerator.getInstance("RSA");
        keyPairGenerator.initialize(1024);
        KeyPair keyPair = keyPairGenerator.generateKeyPair();
        RSAPublicKey rsaPublicKey = (RSAPublicKey) keyPair.getPublic();
        RSAPrivateKey rsaPrivateKey = (RSAPrivateKey) keyPair.getPrivate();
        String publicKeyString = Base64.encodeBase64String(rsaPublicKey.getEncoded());
        String privateKeyString = Base64.encodeBase64String(rsaPrivateKey.getEncoded());
        return new RsaKeyPair(publicKeyString, privateKeyString);
    }

    /**
     * RSA密钥对对象
     */
    public static class RsaKeyPair
    {
        private final String publicKey;
        private final String privateKey;

        public RsaKeyPair(String publicKey, String privateKey)
        {
            this.publicKey = publicKey;
            this.privateKey = privateKey;
        }

        public String getPublicKey()
        {
            return publicKey;
        }

        public String getPrivateKey()
        {
            return privateKey;
        }
    }
}
